package io.gitlab.jfronny.libjf.gson;

import io.gitlab.jfronny.gson.*;

import java.util.List;
import java.util.Map;

public class ForgeGsonGenerator {
    public static JsonElement toGson(Object customValue) {
        //TODO use pattern matching for switch
        if (customValue == null) {
            return JsonNull.INSTANCE;
        } else if (customValue instanceof Map<?, ?> map) {
            JsonObject jo = new JsonObject();
            for (Map.Entry<?, ?> value : map.entrySet())
                jo.add((String) value.getKey(), toGson(value.getValue()));
            return jo;
        } else if (customValue instanceof List<?> array) {
            JsonArray jo = new JsonArray();
            for (Object value : array)
                jo.add(toGson(value));
            return jo;
        } else if (customValue instanceof String s) {
            return new JsonPrimitive(s);
        } else if (customValue instanceof Number n) {
            return new JsonPrimitive(n);
        } else if (customValue instanceof Boolean b) {
            return new JsonPrimitive(b);
        } else {
            throw new IllegalArgumentException("Unsupported type: " + customValue.getClass());
        }
    }
}
