package io.gitlab.jfronny.libjf.log;

import io.gitlab.jfronny.commons.logger.HotswapLoggerFinder;
import io.gitlab.jfronny.commons.logger.LeveledLoggerFinder;
import io.gitlab.jfronny.commons.logger.SystemLoggerPlus;
import org.jetbrains.annotations.Nullable;
import org.slf4j.LoggerFactory;

public class EarlyLoggerSetup extends LeveledLoggerFinder {
    static {
        // On Forge, we shouldn't run the risk of initializing too early, so this should be fine.
        HotswapLoggerFinder.updateAllStrategies((name, module, level) -> new SLF4JPlatformLogger(LoggerFactory.getLogger(name)));
    }

    private final LeveledLoggerFinder delegate = new HotswapLoggerFinder();

    @Override
    public SystemLoggerPlus getLogger(String name, Module module, @Nullable System.Logger.Level level) {
        return delegate.getLogger(name, module, level);
    }
}
