package io.gitlab.jfronny.libjf.config.impl.ui;

import io.gitlab.jfronny.libjf.config.api.v2.ConfigHolder;
import io.gitlab.jfronny.libjf.config.api.v2.ConfigInstance;
import net.minecraft.client.MinecraftClient;
import net.minecraft.client.gui.screen.Screen;
import net.neoforged.bus.api.SubscribeEvent;
import net.neoforged.fml.ModList;
import net.neoforged.fml.event.lifecycle.FMLCommonSetupEvent;
import net.neoforged.neoforge.client.ConfigScreenHandler;

import java.util.Map;
import java.util.function.BiFunction;

public class ModMenuAdapter {
    public static void register(String modId, ConfigInstance config) {
        ModList.get().getModContainerById(modId).ifPresent(modContainer -> {
            modContainer.registerExtensionPoint(ConfigScreenHandler.ConfigScreenFactory.class, () -> new ConfigScreenHandler.ConfigScreenFactory(buildFactory(config)));
        });
    }

    @SubscribeEvent
    public void onInitialize(FMLCommonSetupEvent event) {
        // In case we missed something
        for (Map.Entry<String, ConfigInstance> entry : ConfigHolder.getInstance().getRegistered().entrySet()) {
            register(entry.getKey(), entry.getValue());
        }
    }

    private static BiFunction<MinecraftClient, Screen, Screen> buildFactory(ConfigInstance config) {
        return (client, screen) -> io.gitlab.jfronny.libjf.config.api.v2.ui.ConfigScreenFactory.getInstance().create(config, screen).get();
    }
}
