package io.gitlab.jfronny.libjf.config.impl.entrypoint;

import io.gitlab.jfronny.libjf.LibJf;
import net.minecraft.util.Language;

import java.util.HashSet;
import java.util.Set;
import java.util.function.UnaryOperator;

public class JfConfigSafe {
    public static UnaryOperator<String> TRANSLATION_SUPPLIER = s -> null;
    public static final Set<String> REGISTERED_MODS = new HashSet<>();

    public static void initialize() {
        LibJf.setup();
        // On Forge, configs need to be registered manually
        TRANSLATION_SUPPLIER = s -> {
            String translated;
            try {
                translated = Language.getInstance().get(s);
            } catch (Throwable t) {
                LibJf.LOGGER.debug("Failed to translate key " + s, t);
                return null;
            }
            return translated.equals(s) ? null : translated;
        };
    }
}
